/* Beer Crate 1:10
   Herforder 100er 
 History:  
 - v6 war problematisch, obwohl die Füllung 100% war, war das Ding hohl. Lag evtl. an den 2 oder 3 Shells??
- Außerdem ist ein Griff nicht OK. Und war etwas zu niedrig. (fixed in v7)
- Griffe nach oben verschoben um 1mm. (v8)
- Immernoch hohl (sieht man auch im GCode). Muss wohl die Materialstärke erhöhen. (v9)
   
 */
  
 /* Modules */
include <../../Modules/Module_Geometrical_Objects.scad>;
include <../../Modules/Module_Rounded_Cube.scad>;


/* Globals */ 
$fn=50;
  
gBottleDia=8.0; // 7???
gSpace=0.1;
gMS=1.2+0.4;
gHexSizeInner=gBottleDia+gSpace*2;
gHexSizeOuter=gMS*2+gHexSizeInner;
gHexSizeStep=gHexSizeInner+gMS;
gHexHeight=9+gMS;
gHexCountY=10; // 10*10 = 100er Crate
gHexCountX=9.5; // ;-)
gCrateSizeX=gHexCountX*gHexSizeStep+gHexSizeStep/2*2-1*gMS+0.14; //+gMS; // INNER
//gCrateLength=gHexCount*gHexSizeStep+gHexSizeStep/2-1*gMS; //+gMS; // INNER
gCrateSizeY=(gHexCountY-2)*gHexSizeStep+gHexSizeStep/2*0+3*gMS+0.12+0.35; //+gMS; // INNER
gCrateHeight=17+2.43;
gHandleWidth=20;
gHandleHeight=4;
gCrateRoundDiameter=8.0;

difference()
{
	union()
	{
		//		crateSizeYInner=gCrateLength+2.55; // Calculate correctly, 2.55 = hack!
		//crateSizeYInner=gCrateSizeX+0.2; 

		/* The Crate */
		if (1)
		translate([+gMS*0, +gMS*0, 0]) // Calculate this correctly! Now is a hack (y)!
		{
			lCubeOuterSizeX=gCrateSizeX+1*2*gMS;
			lCubeOuterSizeY=gCrateSizeY+2*gMS;
			lCubeInnerSizeX=gCrateSizeX;
			lCubeInnerSizeY=gCrateSizeY; //crateSizeYInner+2*gMS;
			translate([lCubeOuterSizeX/2, lCubeOuterSizeY/2, gCrateHeight/2])
			difference()
			{
				//translate([-gMS, -gMS*1, 0])
				roundedCube(lCubeOuterSizeX, lCubeOuterSizeY, gCrateHeight, gCrateRoundDiameter);
				
				roundedCube(lCubeInnerSizeX, lCubeInnerSizeY, gCrateHeight, gCrateRoundDiameter);
			} // diff
		}
	
		/* The Hexes */
		if (1)
		translate([gHexSizeOuter/2, (gHexSizeOuter)/2+0.82, 0]) // Calculate correctly, 0.82 = hack!
		{
			for (yi=[0:gHexSizeInner*2:(gHexCountY-2)*gHexSizeStep])
			for (xi=[0:gHexSizeStep:gHexCountX*gHexSizeStep])
			{
				translate([xi, yi, 0])
				hex(gHexSizeOuter, gHexSizeInner, gHexHeight);
			}
			
			for (yi=[gHexSizeInner:gHexSizeInner*2:(gHexCountY-1)*gHexSizeStep])
			for (xi=[gHexSizeStep/2:gHexSizeStep:gHexCountX*gHexSizeStep])
			{
				translate([xi, yi, 0])
				hex(gHexSizeOuter, gHexSizeInner, gHexHeight);
				//echo(xi);
				//echo(yi);
			}
		}
		
		/* Boden */
//		#for (yi=[gHexSizeStep/2:gHexSizeStep:gCrateLength])
		//echo("gHexSizeStep: ", gHexSizeStep);
		//echo("gCrateSizeY: ", gCrateSizeY);
		for (yi=[gHexSizeStep/2:4:gCrateSizeY])
		{
			//echo(yi);
			translate([gMS, yi, 0])
			cube([gCrateSizeX, gMS, gMS]); // not very scale. Sorry.
		}
		
	} // union
	
	/* Handles */
	translate([0, 0, 1])
	{
		translate([gCrateSizeX/2, gMS-0.2, gCrateHeight-gHandleHeight-gMS])
		rotate([90,0,0])
		scale([1, 1/(gHandleWidth/gHandleHeight), 1])
		cylinder(d=gHandleWidth, h=23);
			translate([gCrateSizeX/2, gCrateSizeY+gMS*4-0.4-gMS*2, gCrateHeight-gHandleHeight-gMS])
			rotate([90,0,180])
			scale([1, 1/(gHandleWidth/gHandleHeight), 1])
			cylinder(d=gHandleWidth, h=gMS);
		translate([0, gCrateSizeY/2, gCrateHeight-gHandleHeight-gMS])
		rotate([90,0, 90])
		scale([1, 1/(gHandleWidth/gHandleHeight), 1])
		cylinder(d=gHandleWidth, h=gMS);
			translate([gCrateSizeX+gMS*2+0.2, gCrateSizeY/2, gCrateHeight-gHandleHeight-gMS])
			rotate([90,0,180+90])
			scale([1, 1/(gHandleWidth/gHandleHeight), 1])
			cylinder(d=gHandleWidth, h=gMS);
	}
} // diff



module hex(so, si, h)
{
	difference()
	{
		hexHub(so, h);
		
		hexHub(si, h);
	}
}